package test

import junit.framework.TestCase
import javax.servlet.ServletContext
import org.mortbay.jetty.webapp.WebAppContext
import org.mortbay.jetty.webapp.WebXmlConfiguration
import org.mortbay.jetty.bio.SocketConnector
import org.mortbay.jetty.Server

abstract class JettyTestCase extends TestCase {
    Server server;
    int localPort;
    ServletContext servletContext;
    String contextPath = "/hudson";

    File getWarResourceDirectory() {
        return new File("src/main/webapp");
    }

    void setUp() {
        server = new Server();
        def context = new WebAppContext(getWarResourceDirectory().path, contextPath);
        context.classLoader = this.class.classLoader;
        context.setConfigurations(new WebXmlConfiguration());
        server.setHandler(context);

        def connector = new SocketConnector();
        server.addConnector(connector);
        server.start();

        localPort = connector.localPort;
        servletContext = context.servletContext
        println "Starting Jetty at ${localPort}"
    }

    void tearDown() {
        server.stop();
    }
}